/**
 *                                                                            
 *  Copyright (c) 2011, 2016 - Loetz GmbH&Co.KG (69115 Heidelberg, Germany) 
 *                                                                            
 *  All rights reserved. This program and the accompanying materials           
 *  are made available under the terms of the Eclipse Public License 2.0        
 *  which accompanies this distribution, and is available at                  
 *  https://www.eclipse.org/legal/epl-2.0/                                 
 *                                 
 *  SPDX-License-Identifier: EPL-2.0                                 
 *                                                                            
 *  Contributors:                                                      
 * 	   Christophe Loetz (Loetz GmbH&Co.KG) - initial implementation
 * 
 */
 package org.eclipse.osbp.ecview.core.common.model.core.provider;

import java.util.ArrayList;
import java.util.Collection;

import java.util.List;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ChildCreationExtenderManager;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IChildCreationExtender;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.osbp.ecview.core.common.model.binding.provider.ECViewCoreEditPlugin;
import org.eclipse.osbp.ecview.core.common.model.core.CoreModelPackage;
import org.eclipse.osbp.ecview.core.common.model.core.util.CoreModelAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CoreModelItemProviderAdapterFactory extends CoreModelAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable, IChildCreationExtender {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This helps manage the child creation extenders.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ChildCreationExtenderManager childCreationExtenderManager = new ChildCreationExtenderManager(ECViewCoreEditPlugin.INSTANCE, CoreModelPackage.eNS_URI);

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CoreModelItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link java.util.Map.Entry} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YStringToStringMapItemProvider yStringToStringMapItemProvider;

	/**
	 * This creates an adapter for a {@link java.util.Map.Entry}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYStringToStringMapAdapter() {
		if (yStringToStringMapItemProvider == null) {
			yStringToStringMapItemProvider = new YStringToStringMapItemProvider(this);
		}

		return yStringToStringMapItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YLayout} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YLayoutItemProvider yLayoutItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YLayout}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYLayoutAdapter() {
		if (yLayoutItemProvider == null) {
			yLayoutItemProvider = new YLayoutItemProvider(this);
		}

		return yLayoutItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YHelperLayout} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YHelperLayoutItemProvider yHelperLayoutItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YHelperLayout}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYHelperLayoutAdapter() {
		if (yHelperLayoutItemProvider == null) {
			yHelperLayoutItemProvider = new YHelperLayoutItemProvider(this);
		}

		return yHelperLayoutItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YField} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YFieldItemProvider yFieldItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YField}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYFieldAdapter() {
		if (yFieldItemProvider == null) {
			yFieldItemProvider = new YFieldItemProvider(this);
		}

		return yFieldItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YView} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YViewItemProvider yViewItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YView}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYViewAdapter() {
		if (yViewItemProvider == null) {
			yViewItemProvider = new YViewItemProvider(this);
		}

		return yViewItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YViewSet} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YViewSetItemProvider yViewSetItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YViewSet}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYViewSetAdapter() {
		if (yViewSetItemProvider == null) {
			yViewSetItemProvider = new YViewSetItemProvider(this);
		}

		return yViewSetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YBeanSlot} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YBeanSlotItemProvider yBeanSlotItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YBeanSlot}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYBeanSlotAdapter() {
		if (yBeanSlotItemProvider == null) {
			yBeanSlotItemProvider = new YBeanSlotItemProvider(this);
		}

		return yBeanSlotItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YDetailBeanSlot} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YDetailBeanSlotItemProvider yDetailBeanSlotItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YDetailBeanSlot}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYDetailBeanSlotAdapter() {
		if (yDetailBeanSlotItemProvider == null) {
			yDetailBeanSlotItemProvider = new YDetailBeanSlotItemProvider(this);
		}

		return yDetailBeanSlotItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YDialog} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YDialogItemProvider yDialogItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YDialog}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYDialogAdapter() {
		if (yDialogItemProvider == null) {
			yDialogItemProvider = new YDialogItemProvider(this);
		}

		return yDialogItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YActionItemProvider yActionItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYActionAdapter() {
		if (yActionItemProvider == null) {
			yActionItemProvider = new YActionItemProvider(this);
		}

		return yActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YContextValueBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YContextValueBindingEndpointItemProvider yContextValueBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YContextValueBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYContextValueBindingEndpointAdapter() {
		if (yContextValueBindingEndpointItemProvider == null) {
			yContextValueBindingEndpointItemProvider = new YContextValueBindingEndpointItemProvider(this);
		}

		return yContextValueBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YBeanSlotValueBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YBeanSlotValueBindingEndpointItemProvider yBeanSlotValueBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YBeanSlotValueBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYBeanSlotValueBindingEndpointAdapter() {
		if (yBeanSlotValueBindingEndpointItemProvider == null) {
			yBeanSlotValueBindingEndpointItemProvider = new YBeanSlotValueBindingEndpointItemProvider(this);
		}

		return yBeanSlotValueBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YBeanSlotListBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YBeanSlotListBindingEndpointItemProvider yBeanSlotListBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YBeanSlotListBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYBeanSlotListBindingEndpointAdapter() {
		if (yBeanSlotListBindingEndpointItemProvider == null) {
			yBeanSlotListBindingEndpointItemProvider = new YBeanSlotListBindingEndpointItemProvider(this);
		}

		return yBeanSlotListBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableValueEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YEmbeddableValueEndpointItemProvider yEmbeddableValueEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableValueEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYEmbeddableValueEndpointAdapter() {
		if (yEmbeddableValueEndpointItemProvider == null) {
			yEmbeddableValueEndpointItemProvider = new YEmbeddableValueEndpointItemProvider(this);
		}

		return yEmbeddableValueEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableSelectionEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YEmbeddableSelectionEndpointItemProvider yEmbeddableSelectionEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableSelectionEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYEmbeddableSelectionEndpointAdapter() {
		if (yEmbeddableSelectionEndpointItemProvider == null) {
			yEmbeddableSelectionEndpointItemProvider = new YEmbeddableSelectionEndpointItemProvider(this);
		}

		return yEmbeddableSelectionEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableMultiSelectionEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YEmbeddableMultiSelectionEndpointItemProvider yEmbeddableMultiSelectionEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableMultiSelectionEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYEmbeddableMultiSelectionEndpointAdapter() {
		if (yEmbeddableMultiSelectionEndpointItemProvider == null) {
			yEmbeddableMultiSelectionEndpointItemProvider = new YEmbeddableMultiSelectionEndpointItemProvider(this);
		}

		return yEmbeddableMultiSelectionEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableCollectionEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YEmbeddableCollectionEndpointItemProvider yEmbeddableCollectionEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableCollectionEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYEmbeddableCollectionEndpointAdapter() {
		if (yEmbeddableCollectionEndpointItemProvider == null) {
			yEmbeddableCollectionEndpointItemProvider = new YEmbeddableCollectionEndpointItemProvider(this);
		}

		return yEmbeddableCollectionEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YActivatedEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YActivatedEndpointItemProvider yActivatedEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YActivatedEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYActivatedEndpointAdapter() {
		if (yActivatedEndpointItemProvider == null) {
			yActivatedEndpointItemProvider = new YActivatedEndpointItemProvider(this);
		}

		return yActivatedEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YDtWrapper} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YDtWrapperItemProvider yDtWrapperItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YDtWrapper}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYDtWrapperAdapter() {
		if (yDtWrapperItemProvider == null) {
			yDtWrapperItemProvider = new YDtWrapperItemProvider(this);
		}

		return yDtWrapperItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YCommandSet} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YCommandSetItemProvider yCommandSetItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YCommandSet}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYCommandSetAdapter() {
		if (yCommandSetItemProvider == null) {
			yCommandSetItemProvider = new YCommandSetItemProvider(this);
		}

		return yCommandSetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YOpenDialogCommand} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YOpenDialogCommandItemProvider yOpenDialogCommandItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YOpenDialogCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYOpenDialogCommandAdapter() {
		if (yOpenDialogCommandItemProvider == null) {
			yOpenDialogCommandItemProvider = new YOpenDialogCommandItemProvider(this);
		}

		return yOpenDialogCommandItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YExposedAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YExposedActionItemProvider yExposedActionItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YExposedAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYExposedActionAdapter() {
		if (yExposedActionItemProvider == null) {
			yExposedActionItemProvider = new YExposedActionItemProvider(this);
		}

		return yExposedActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YSendEventCommand} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YSendEventCommandItemProvider ySendEventCommandItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YSendEventCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYSendEventCommandAdapter() {
		if (ySendEventCommandItemProvider == null) {
			ySendEventCommandItemProvider = new YSendEventCommandItemProvider(this);
		}

		return ySendEventCommandItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YKeyStrokeDefinition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YKeyStrokeDefinitionItemProvider yKeyStrokeDefinitionItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YKeyStrokeDefinition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYKeyStrokeDefinitionAdapter() {
		if (yKeyStrokeDefinitionItemProvider == null) {
			yKeyStrokeDefinitionItemProvider = new YKeyStrokeDefinitionItemProvider(this);
		}

		return yKeyStrokeDefinitionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YDelegateConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YDelegateConverterItemProvider yDelegateConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YDelegateConverter}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYDelegateConverterAdapter() {
		if (yDelegateConverterItemProvider == null) {
			yDelegateConverterItemProvider = new YDelegateConverterItemProvider(this);
		}

		return yDelegateConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YEmbeddableEventItemProvider yEmbeddableEventItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YEmbeddableEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYEmbeddableEventAdapter() {
		if (yEmbeddableEventItemProvider == null) {
			yEmbeddableEventItemProvider = new YEmbeddableEventItemProvider(this);
		}

		return yEmbeddableEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.core.YContextClickEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YContextClickEventItemProvider yContextClickEventItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.core.YContextClickEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYContextClickEventAdapter() {
		if (yContextClickEventItemProvider == null) {
			yContextClickEventItemProvider = new YContextClickEventItemProvider(this);
		}

		return yContextClickEventItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<IChildCreationExtender> getChildCreationExtenders() {
		return childCreationExtenderManager.getChildCreationExtenders();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection<?> getNewChildDescriptors(Object object, EditingDomain editingDomain) {
		return childCreationExtenderManager.getNewChildDescriptors(object, editingDomain);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return childCreationExtenderManager;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (yStringToStringMapItemProvider != null) yStringToStringMapItemProvider.dispose();
		if (yLayoutItemProvider != null) yLayoutItemProvider.dispose();
		if (yHelperLayoutItemProvider != null) yHelperLayoutItemProvider.dispose();
		if (yFieldItemProvider != null) yFieldItemProvider.dispose();
		if (yViewItemProvider != null) yViewItemProvider.dispose();
		if (yViewSetItemProvider != null) yViewSetItemProvider.dispose();
		if (yBeanSlotItemProvider != null) yBeanSlotItemProvider.dispose();
		if (yDetailBeanSlotItemProvider != null) yDetailBeanSlotItemProvider.dispose();
		if (yDialogItemProvider != null) yDialogItemProvider.dispose();
		if (yActionItemProvider != null) yActionItemProvider.dispose();
		if (yContextValueBindingEndpointItemProvider != null) yContextValueBindingEndpointItemProvider.dispose();
		if (yBeanSlotValueBindingEndpointItemProvider != null) yBeanSlotValueBindingEndpointItemProvider.dispose();
		if (yBeanSlotListBindingEndpointItemProvider != null) yBeanSlotListBindingEndpointItemProvider.dispose();
		if (yEmbeddableValueEndpointItemProvider != null) yEmbeddableValueEndpointItemProvider.dispose();
		if (yEmbeddableSelectionEndpointItemProvider != null) yEmbeddableSelectionEndpointItemProvider.dispose();
		if (yEmbeddableMultiSelectionEndpointItemProvider != null) yEmbeddableMultiSelectionEndpointItemProvider.dispose();
		if (yEmbeddableCollectionEndpointItemProvider != null) yEmbeddableCollectionEndpointItemProvider.dispose();
		if (yActivatedEndpointItemProvider != null) yActivatedEndpointItemProvider.dispose();
		if (yDtWrapperItemProvider != null) yDtWrapperItemProvider.dispose();
		if (yCommandSetItemProvider != null) yCommandSetItemProvider.dispose();
		if (yOpenDialogCommandItemProvider != null) yOpenDialogCommandItemProvider.dispose();
		if (yExposedActionItemProvider != null) yExposedActionItemProvider.dispose();
		if (ySendEventCommandItemProvider != null) ySendEventCommandItemProvider.dispose();
		if (yKeyStrokeDefinitionItemProvider != null) yKeyStrokeDefinitionItemProvider.dispose();
		if (yDelegateConverterItemProvider != null) yDelegateConverterItemProvider.dispose();
		if (yEmbeddableEventItemProvider != null) yEmbeddableEventItemProvider.dispose();
		if (yContextClickEventItemProvider != null) yContextClickEventItemProvider.dispose();
	}

}
